Index: drivers/serial/tsuart73.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/serial/tsuart73.c,v
retrieving revision 1.1
retrieving revision 1.6
diff -u -r1.1 -r1.6
--- drivers/serial/tsuart73.c	23 Jan 2006 19:00:59 -0000	1.1
+++ drivers/serial/tsuart73.c	24 Apr 2006 18:14:21 -0000	1.6
@@ -1,5 +1,5 @@
 /*
- *  linux/drivers/serial/tsuart.c
+ *  linux/drivers/serial/tsuart73.c
  *
  *  Driver for Technologic Systems UART
  *
@@ -11,6 +11,7 @@
  * 2005-11-17:mos:initial version completed
  * 2005-11-18:mos:added proper hardware flow control support (Tx)
  * 2006-01-18:mos:cleanup;now using memory access instead of inb/outb
+ * 2006-01-26:mos:added support for 9-bit mode
  */
 /*
   1. Add support for 9-bit serial
@@ -18,9 +19,36 @@
   -in 9-bit mode we take/return two bytes per write/read
   -we must make sure everything is flushed when we enter/leave this mode
    so that we never lose synchronization
+
+   9-bit mode is implemented with a separate device (ttyT9Sx).
+   The 8 and 9 bit devices for a port are prohibited from being open at
+   the same time.
+
+   Fetch data to read a byte at a time until we see a valid most
+   significant byte (x & 0xFE == 0).
+
   2. Add support for software based parity (8+1,7+1). Tell the hardware to
   use one more data bit, then use it for parity.
  */
+/*
+  Implementation
+  1. Implement functions to 
+     (a) get current 8/9 bit mode status
+     (b) set current 8/9 bit mode status
+     DONE
+  2. Identify where we actually need to use the above functions, and
+     create a cache of each port's status so we can use it for frequent
+     access.
+     1. Calling TXDAT or RXDAT.  I think we might simply hide the
+     8/16 bit difference in these functions, and have them track the
+     state.
+     DONE
+  3. Identify everywhere that RXDAT is currently being used. Change
+     each location to use 8/16 bits depending on the current mode.
+     Modify write logic to synchronize byte-wise on msB & 0xFE == 0,
+     and read logic to clear those bits.
+     DONE
+ */
 #include <linux/slab.h>
 #include <linux/config.h>
 #include <linux/module.h>
@@ -45,7 +73,7 @@
 #define DELAY_TIME      HZ / 100        // 100 Hz
 #define UART_PORT_SIZE  64              // not used
 #define PORT_TSUART     55              // see include/linux/serial_core.c
-#define UART_NR		8
+#define UART_NR		16
 #define UART_CLOCK	14745600	// not used
 #define UART_FIFOSIZE	5		// not used
 
@@ -53,8 +81,10 @@
 #define SERIAL_TSUART_MINOR	1
 #define SERIAL_TSUART_NR	UART_NR
 #define SERIAL_TSUART_NAME	"ttyTS"
+#define SERIAL_TSUART9_NAME	"ttyT9S"
 
 #define CALLOUT_TSUART_NAME	"cuats"
+#define CALLOUT_TSUART9_NAME	"cuat9s"
 #define CALLOUT_TSUART_MAJOR	235
 #define CALLOUT_TSUART_MINOR	1
 #define CALLOUT_TSUART_NR	UART_NR
@@ -69,14 +99,16 @@
 // Forward Declarations <
 //-----------------------
 
+int running[8];
 static struct uart_port tsuart_ports[];
 static void tsuart_stop_tx(struct uart_port *port, unsigned int tty_stop);
 static struct timer_list timer;
 static int timer_added = 0;
-#define TSUART_DEBUG
+//#define TSUART_DEBUG
 //#define DEBUG_IO
-#define DEBUG_IRQ
-#define TSUART_DEBUG_DATA
+//#define DEBUG_IO2
+//#define DEBUG_IRQ
+//#define TSUART_DEBUG_DATA
 //#define TSUART_STATS
 //-----------------------------------------------------------------------
 //                                                                      /
@@ -185,16 +217,32 @@
   *STAT = value;
 }
 
+static inline int bit_MODE9(unsigned short reg_value);
+static inline unsigned short assign_bit_MODE9(unsigned short reg_value,int set);
+static inline int MODE9(struct uart_port *port) {
+  return (bit_MODE9(get_tsuart_STAT(port)) != 0);
+}
+
+static inline void set_MODE9(struct uart_port *port,int on) {
+  put_tsuart_STAT(port,assign_bit_MODE9(get_tsuart_STAT(port),on));
+}
+
+#define rXmsB port->unused[0]
+#define tXmsB port->unused[1]
+#define tXdaTmsB port->unused[2]
+#define rXdaTlsB port->unused[3]
+#define NINER port->unused[4]
+/*
+ */
 // read the TS UART RXDAT register for the specified UART
 static inline int get_tsuart_RXDAT(struct uart_port *port) {
   volatile unsigned short *DAT = (unsigned short *)port->membase;
-  unsigned short tmp;
 
-  tmp = DAT[1];
-#ifdef DEBUG_IO
-  printk("***RX port %d, data=%X\n",port->line,tmp);
-#endif
-  return tmp;
+  if (running[port->line] == 9) {
+    return DAT[1] & 0x1FF;
+  } else {
+    return DAT[1] & 0xFF;
+  }
 }
 
 // write the TS UART TXDAT register for the specified UART
@@ -204,7 +252,32 @@
 #ifdef DEBUG_IO
   printk("***TX port %d, data=%X\n",port->line,data);
 #endif
-  DAT[1] = data;
+#ifdef DEBUG_IO2
+    printk("Tx with stat=%X\n",get_tsuart_STAT(port));
+#endif
+  if (MODE9(port)) {
+    if (tXmsB) {
+#ifdef TSUART_DEBUG_DATA
+      printk("tXmsb=%d,data=%X\n",tXmsB,data);
+#endif
+      if ((data & 0xFE) == 0) {
+	tXdaTmsB = data;
+	tXmsB = !tXmsB;
+      } else {
+#ifdef DEBUG_IO
+	printk("***TX Rejected (sync)\n");
+#endif
+      }
+    } else {
+#ifdef TSUART_DEBUG_DATA
+      printk("tXmsb=%d,writing %X\n",tXmsB,(((unsigned short)tXdaTmsB) << 8) + (data & 0xFF));
+#endif
+      DAT[1] = (((unsigned short)tXdaTmsB) << 8) + (data & 0xFF);
+      tXmsB = !tXmsB;
+    }
+  } else {
+      DAT[1] = data & 0xFF;
+  }
 }
 
 static inline int get_tsuart_TRI(void) {
@@ -219,7 +292,7 @@
 int rxof=0;
 int mincounter=256;
 // lets us receive multiple devices before pushing it up
-int gotbytes[8],flushing[8];
+int gotbytes[UART_NR],flushing[UART_NR];
 
 // process the byte in the lsb of data by sending it to the
 // appropriate OS buffers for the given TS UART UART
@@ -228,6 +301,7 @@
   unsigned int ch = data;
 
 #ifdef TSUART_DEBUG_DATA
+  printk("(%d):",port-tsuart_ports);
   printk("Rx%d:%02X%s\n",port->line,ch,port->info?"":"?");
 #endif
   if (!port->info || flushing[port->line]) {
@@ -241,13 +315,18 @@
   if (tty->flip.count >= TTY_FLIPBUF_SIZE) {
     tty_flip_buffer_push(tty); 
   }
-  tty_insert_flip_char(tty, ch, 0);
+  if (running[port->line] == 9) {
+    tty_insert_flip_char(tty, (ch >> 8) & 1, 0);
+    tty_insert_flip_char(tty, ch & 0xFF, 0);
+  } else {
+    tty_insert_flip_char(tty, ch, 0);
+  }
   gotbytes[port->line]++;
   return; 
 }
 
 static unsigned int total_sent = 0;
-static inline int bit_CTS(unsigned char reg_value);
+static inline int bit_CTS(unsigned short reg_value);
 // If there is data ready to be transmitted for the given UART,
 // then feed to the byte to the UART
 static void tsuart_try_handleTx(struct uart_port *port) {
@@ -272,17 +351,18 @@
   }
   xmit = &port->info->xmit;
   if (uart_circ_empty(xmit) || uart_tx_stopped(port)) {
-    /*
+#ifdef TSUART_DEBUG
     if (uart_tx_stopped(port)) {
       printk("tx stop detected\n");
     }
-    */
+#endif
     tsuart_stop_tx(port,0);
     return;
   }
   // handle one character
   ch = xmit->buf[xmit->tail];
 #ifdef TSUART_DEBUG_DATA
+  printk("(%d):",port-tsuart_ports);
   printk("Tx%d:%02X%s\n",port->line,ch,port->info?"":"?");
 #endif
   total_sent++;
@@ -296,7 +376,7 @@
   }
   if (uart_circ_empty(xmit)) {
 #ifdef TSUART_DEBUG
-    //    printk("Stopping xmit at end\n");
+    printk("Stopping xmit at end\n");
 #endif
     tsuart_stop_tx(port, 0);
   }
@@ -307,46 +387,54 @@
 // Begin FPGA dependant code <
 //----------------------------
 
+static inline int bit_MODE9(unsigned short reg_value) {
+  return (reg_value & 0x100) == 0x100;
+}
+
 // accepts the value read from the TS UART STAT register
 // returns TRUE if the TBRE bit is set, and FALSE if it is clear
-static inline int bit_TBRE(unsigned char reg_value) {
+static inline int bit_TBRE(unsigned short reg_value) {
   return (reg_value & 0x01) == 0x01;
 }
 
 // accepts the value read from the TS UART STAT register
 // returns TRUE if the DR bit is set, and FALSE if it is clear
-static inline int bit_DR(unsigned char reg_value) {
+static inline int bit_DR(unsigned short reg_value) {
   return (reg_value & 0x02) == 0x02;
 }
 
 // accepts the value read from the TS UART STAT register
 // returns TRUE if the OERR bit is set, and FALSE if it is clear
-static inline int bit_OERR(unsigned char reg_value) {
+static inline int bit_OERR(unsigned short reg_value) {
   return (reg_value & 0x04) == 0x04;
 }
 
 // accepts the value read from the TS UART STAT register
 // returns TRUE if the CTS bit is set, and FALSE if it is clear
-static inline int bit_CTS(unsigned char reg_value) {
+static inline int bit_CTS(unsigned short reg_value) {
   return (reg_value & 0x08) == 0x08;
 }
 
 // accepts the value read from the TS UART STAT register
 // returns TRUE if the RTS bit is set, and FALSE if it is clear
-static inline int bit_RTS(unsigned char reg_value) {
+static inline int bit_RTS(unsigned short reg_value) {
   return (reg_value & 0x10) == 0x10;
 }
 
+static inline unsigned short assign_bit_MODE9(unsigned short reg_value,int set) {
+  return (reg_value & ~0x100) | (set ? 0x100 : 0);
+}
+
 // accepts the value read from the TS UART STAT register
 // If set is TRUE, sets the RTS bit, others clears it,
 // and returns the new value to be written back to the STAT register
-static inline unsigned char assign_bit_RTS(unsigned char reg_value,int set) {
+static inline unsigned short assign_bit_RTS(unsigned short reg_value,int set) {
   return (reg_value & ~0x10) | (set ? 0x10 : 0);
 }
 
 // accepts the value read from the TS UART STAT register
 // returns the baud rate
-static int bits_BAUD(unsigned char reg_value) {
+static int bits_BAUD(unsigned short reg_value) {
   int encoded_rate;
 
   encoded_rate = (reg_value & 0xE0) >> 5;
@@ -366,15 +454,15 @@
 // accepts the value read from the TS UART STAT register,
 // and the encoded baud rate to set, and returns the value to be written
 // back to the STAT register.
-static inline unsigned char encode_BAUD(unsigned char reg_value,int bits) {
-  return (reg_value & 0x1F) | (bits << 5);
+static inline unsigned short encode_BAUD(unsigned short reg_value,int bits) {
+  return (reg_value & 0xFF1F) | (bits << 5);
 }
 
 // accepts the value read from the TS UART STAT register,
 // encodes the given baud rate, and then returns the value to be written
 // back to the STAT register.  If the passed baud rate is not supported
 // the passed value is returned unchanged.
-static unsigned char assign_bits_BAUD(unsigned char reg_value,int baud_rate) {
+static unsigned short assign_bits_BAUD(unsigned short reg_value,int baud_rate) {
   switch (baud_rate) {
   case 115200: return encode_BAUD(reg_value,0);
   case 57600:  return encode_BAUD(reg_value,1);
@@ -475,7 +563,7 @@
 //---------------------
 
 int tsuart_sanity_check_STAT(struct uart_port *port) {
-  unsigned char stat;
+  unsigned short stat;
 
   stat = get_tsuart_STAT(port);
   put_tsuart_STAT(port,stat | 0x0F);
@@ -483,7 +571,7 @@
 }
 
 int tsuart_sanity_check_baud(struct uart_port *port,int rate) {
-  unsigned char stat;
+  unsigned short stat;
 
   stat = get_tsuart_STAT(port);
   put_tsuart_STAT(port,assign_bits_BAUD(stat,rate));
@@ -571,14 +659,18 @@
   }
 
 #ifdef DEBUG_IRQ
-  printk("*** int3\n");
+  printk("*** int8\n");
 #endif
   while (--counter) {
     for (i=0;i<8;i++) {
       data[i] = -1;
     }
     for (i=0;i<8;i++) {
-      tsuart_checkRx(port+i,data+i);
+      if (running[i] == 9) {
+	tsuart_checkRx(port+i+8,data+i);
+      } else {
+	tsuart_checkRx(port+i,data+i);
+      }
     }
     for (i=0;i<8;i++) {
       if (data[i] != -1) {
@@ -589,12 +681,20 @@
       break;
     }
     for (i=0;i<8;i++) {
-      tsuart_try_handleRx(port+i,data[i]);
+      if (running[i] == 9) {
+	tsuart_try_handleRx(port+i+8,data[i]);
+      } else {
+	tsuart_try_handleRx(port+i,data[i]);
+      }
     }
   }
   if (counter < mincounter) { mincounter = counter; }
   for (i=0;i<8;i++) {
-    tsuart_checkHandleTx(port+i);
+    if (running[i] == 9) {
+      tsuart_checkHandleTx(port+i+8);
+    } else {
+      tsuart_checkHandleTx(port+i);
+    }
   }
   for (i=0;i<8;i++) {
     if (gotbytes[i]) {
@@ -604,7 +704,11 @@
 #ifdef TSUART_DEBUG_DATA
       printk("tsuart: pushing buffer %d\n",i);
 #endif
-      tty_flip_buffer_push((port+i)->info->tty);
+      if (running[i] == 9) {
+	tty_flip_buffer_push((port+i+8)->info->tty);
+      } else {
+	tty_flip_buffer_push((port+i)->info->tty);
+      }
     }
   }
 }
@@ -718,10 +822,16 @@
 #ifdef TSUART_STATS
   int i;
 #endif
+  int tmp;
 
+  if (running[port->line]) {
+    return -EBUSY; // already open!
+  }
+  running[port->line] = NINER ? 9 : 8;
   if (started++) {
     return 0;
   }
+  set_MODE9(port,NINER?1:0);
 
   /* create our timer but don't submit it just yet */
   timer.data = (unsigned long )port;
@@ -736,9 +846,10 @@
 #ifdef TSUART_DEBUG
   printk("tsuart_startup called, irq=%d\n",port->irq);
   printk("membase=%p\nmapbase=%lX\n",port->membase,port->mapbase);
+  printk("port=%d,NINER=%d\n",port-tsuart_ports,NINER);
 #endif
-  return request_irq(port->irq, tsuart_int8, 0, "tsuart_uarts", port);
-  return 0;
+  tmp = request_irq(port->irq, tsuart_int8, SA_SHIRQ, "tsuart_uarts", port);
+  return tmp;
 }
 
 static void tsuart_shutdown(struct uart_port *port)
@@ -747,6 +858,8 @@
   int i;
 #endif
 
+  running[port->line] = 0;
+
   if (--started) {
     return;
   }
@@ -795,7 +908,7 @@
     flushing[port->line] = 0;
   } else {
     printk("tsuart:unknown change_speed, port %d: %X\n",port->line,encoded_baud);
-    printk("%08X & %08X -> %08X\n",cflag,CBAUD,cflag & CBAUD);
+    //    printk("%08X & %08X -> %08X\n",cflag,CBAUD,cflag & CBAUD);
   }
 
   if (cflag & PARENB) {
@@ -828,6 +941,11 @@
  */
 static void tsuart_release_port(struct uart_port *port)
 {
+  if (port > &tsuart_ports[7]) {
+    port->membase = 0;
+    return;
+  }
+
 #ifdef TSUART_DEBUG
   printk("tsuart_release_port called, membase=%p\n",port->membase);
 #endif
@@ -842,13 +960,18 @@
  */
 static int tsuart_request_port(struct uart_port *port)
 {
+  if (port > &tsuart_ports[7]) {
+    struct uart_port *base = &tsuart_ports[(port - &tsuart_ports[8])];
+    port->membase = base->membase;
+    return 0;
+  }
 #ifdef TSUART_DEBUG
   printk("tsuart_request_port called, mapbase=%lX\n",port->mapbase);
 #endif
   // call __ioremap to avoid a IO to PHY translation - we already have
   // the PHYsical address!
   if (port->membase == 0) {
-    port->membase = (unsigned int) __ioremap(
+    port->membase = (void *) __ioremap(
 			      port->mapbase & 0xFFFFF000, 4096,0) 
       + (port->mapbase & 0xFFF);
   }
@@ -878,7 +1001,9 @@
 static int tsuart_verify_port(struct uart_port *port, struct serial_struct *ser)
 {
   int ret = 0;
-
+#ifdef TSUART_DEBUG
+  printk("tsuart_verify_port\n");
+#endif
   if (port == NULL) return -EINVAL; // avoid warning
   if (ser->type != PORT_UNKNOWN && ser->type != PORT_TSUART)
     ret = -EINVAL;
@@ -886,6 +1011,9 @@
     ret = -EINVAL;
   //  if (ser->baud_base != 115200)
   //    ret = -EINVAL;
+#ifdef TSUART_DEBUG
+  printk("tsuart_verify_port returns %d\n",ret);
+#endif
   return ret;
 }
 
@@ -926,7 +1054,96 @@
 	.ioctl		= tsuart_ioctls,
 };
 
-static struct uart_port tsuart_ports[8] = {
+static struct uart_port tsuart_ports[16] = {
+	{
+	  .membase	= 0,
+	  .mapbase	= TSUART1_BASE,
+	  .iotype	= SERIAL_IO_MEM,
+	  .irq		= TSUART_IRQ,
+	  .uartclk	= UART_CLOCK,
+	  .fifosize	= UART_FIFOSIZE,
+	  .ops		= &tsuart_ops,
+	  .flags	= ASYNC_BOOT_AUTOCONF,
+	  .line		= 0,
+	},
+	{
+	  .membase	= 0,
+	  .mapbase	= TSUART1_BASE+4,
+	  .iotype	= SERIAL_IO_MEM,
+	  .irq		= TSUART_IRQ,
+	  .uartclk	= UART_CLOCK,
+	  .fifosize	= UART_FIFOSIZE,
+	  .ops		= &tsuart_ops,
+	  .flags	= ASYNC_BOOT_AUTOCONF,
+	  .line		= 1,
+	},
+	{
+	  .membase	= 0,
+	  .mapbase	= TSUART1_BASE+8,
+	  .iotype	= SERIAL_IO_MEM,
+	  .irq		= TSUART_IRQ,
+	  .uartclk	= UART_CLOCK,
+	  .fifosize	= UART_FIFOSIZE,
+	  .ops		= &tsuart_ops,
+	  .flags	= ASYNC_BOOT_AUTOCONF,
+	  .line		= 2,
+	},
+	{
+	  .membase	= 0,
+	  .mapbase	= TSUART1_BASE+12,
+	  .iotype	= SERIAL_IO_MEM,
+	  .irq		= TSUART_IRQ,
+	  .uartclk	= UART_CLOCK,
+	  .fifosize	= UART_FIFOSIZE,
+	  .ops		= &tsuart_ops,
+	  .flags	= ASYNC_BOOT_AUTOCONF,
+	  .line		= 3,
+	},
+	{
+	  .membase	= 0,
+	  .mapbase	= TSUART1_BASE+16,
+	  .iotype	= SERIAL_IO_MEM,
+	  .irq		= TSUART_IRQ,
+	  .uartclk	= UART_CLOCK,
+	  .fifosize	= UART_FIFOSIZE,
+	  .ops		= &tsuart_ops,
+	  .flags	= ASYNC_BOOT_AUTOCONF,
+	  .line		= 4,
+	},
+	{
+	  .membase	= 0,
+	  .mapbase	= TSUART1_BASE+20,
+	  .iotype	= SERIAL_IO_MEM,
+	  .irq		= TSUART_IRQ,
+	  .uartclk	= UART_CLOCK,
+	  .fifosize	= UART_FIFOSIZE,
+	  .ops		= &tsuart_ops,
+	  .flags	= ASYNC_BOOT_AUTOCONF,
+	  .line		= 5,
+	},
+	{
+	  .membase	= 0,
+	  .mapbase	= TSUART1_BASE+24,
+	  .iotype	= SERIAL_IO_MEM,
+	  .irq		= TSUART_IRQ,
+	  .uartclk	= UART_CLOCK,
+	  .fifosize	= UART_FIFOSIZE,
+	  .ops		= &tsuart_ops,
+	  .flags	= ASYNC_BOOT_AUTOCONF,
+	  .line		= 6,
+	},
+	{
+	  .membase	= 0,
+	  .mapbase	= TSUART1_BASE+28,
+	  .iotype	= SERIAL_IO_MEM,
+	  .irq		= TSUART_IRQ,
+	  .uartclk	= UART_CLOCK,
+	  .fifosize	= UART_FIFOSIZE,
+	  .ops		= &tsuart_ops,
+	  .flags	= ASYNC_BOOT_AUTOCONF,
+	  .line		= 7,
+	},
+
 	{
 	  .membase	= 0,
 	  .mapbase	= TSUART1_BASE,
@@ -1018,6 +1235,7 @@
 };
 
 static struct tty_driver normal, callout;
+static struct tty_driver normal2, callout2;
 static struct tty_struct *cs_tsuart_table[UART_NR];
 static struct termios *cs_tsuart_termios[UART_NR], 
 			*cs_tsuart_termios_locked[UART_NR];
@@ -1039,7 +1257,28 @@
 	.termios		= cs_tsuart_termios,
 	.termios_locked	        = cs_tsuart_termios_locked,
 	.minor			= SERIAL_TSUART_MINOR,
-	.nr			= UART_NR,
+	.nr			= UART_NR/2,
+	.cons			= NULL,
+};
+
+static struct uart_driver tsuart9_reg = {
+	.owner			= THIS_MODULE,
+	.normal_major		= SERIAL_TSUART_MAJOR,
+#ifdef CONFIG_DEVFS_FS
+	.normal_name		= SERIAL_TSUART9_NAME "%d",
+	.callout_name		= CALLOUT_TSUART9_NAME "%d",
+#else
+	.normal_name		= SERIAL_TSUART9_NAME,
+	.callout_name		= CALLOUT_TSUART9_NAME,
+#endif
+	.normal_driver		= &normal2,
+	.callout_major		= CALLOUT_TSUART_MAJOR,
+	.callout_driver		= &callout2,
+	.table			= &cs_tsuart_table[8],
+	.termios		= &cs_tsuart_termios[8],
+	.termios_locked	        = &cs_tsuart_termios_locked[8],
+	.minor			= SERIAL_TSUART_MINOR+8,
+	.nr			= UART_NR/2,
 	.cons			= NULL,
 };
 
@@ -1060,12 +1299,18 @@
 	}
 	*/
 	ret = uart_register_driver(&tsuart_reg);
+	ret |= uart_register_driver(&tsuart9_reg);
 	if (ret == 0) {
 		int i;
 
 		for (i=0;i<UART_NR;i++) {
  		        flushing[i] = 0;
-			uart_add_one_port(&tsuart_reg,&tsuart_ports[i]);
+			running[i] = 0;
+			tsuart_ports[i].unused[0] = 1;
+			tsuart_ports[i].unused[1] = 1;
+			tsuart_ports[i].unused[4] = (i > 7);
+			uart_add_one_port(i < 8 ? &tsuart_reg:&tsuart9_reg,
+					  &tsuart_ports[i]);
 		}
 	}
 	return ret;
@@ -1076,9 +1321,11 @@
 	int i;
 
 	procfile_exit();
-	for (i=0;i<UART_NR;i++)
-		uart_remove_one_port(&tsuart_reg, &tsuart_ports[i]);
-
+	for (i=0;i<UART_NR;i++) {
+		uart_remove_one_port(i < 8 ? &tsuart_reg:&tsuart9_reg, 
+				     &tsuart_ports[i]);
+	}
+	uart_unregister_driver(&tsuart9_reg);
 	uart_unregister_driver(&tsuart_reg);
 }
 
Index: drivers/serial/tsuart7400.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/serial/tsuart7400.c,v
retrieving revision 1.1
retrieving revision 1.5
diff -u -r1.1 -r1.5
--- drivers/serial/tsuart7400.c	25 Sep 2006 21:46:23 -0000	1.1
+++ drivers/serial/tsuart7400.c	31 Jan 2007 22:38:09 -0000	1.5
@@ -32,7 +32,24 @@
 #include <linux/ts_sbc.h>
 #include <asm/uaccess.h>
 #include "tsuart.h"
+#include "ts7412.h"
 
+static int mdmctrl(struct tsuart_port *ts,int mctrl) {
+  int ctrl=mctrl;
+
+  if (mctrl & 0x80000000) {
+    mdmctrl_dtr_set((mctrl & TIOCM_DTR)?1:0);
+    mdmctrl_rts_set((mctrl & TIOCM_RTS)?1:0);
+  } else {
+    if (mdmctrl_dcd_get()) {
+      ctrl |= TIOCM_CAR;
+    }
+    if (mdmctrl_cts_get()) {
+      ctrl |= TIOCM_CTS;
+    }
+  }
+  return (TIOCM_DSR | ctrl);
+}
 
 #define BOARD_ID_7400 0x7400
 static int tryInitPort(int base) {
@@ -48,10 +65,10 @@
   ts->u.iotype = SERIAL_IO_MEM;
   ts->get = tsuartGetMEM8;
   ts->put = tsuartPutMEM8;
-  ts->mdmctrl = 0;
+  ts->mdmctrl = (gpio == 0) ? 0 : mdmctrl;
   ts->debugFlags = portDebug;
   ts->u.mapbase = /*0 x72000000 + */ base;
-  ts->u.irq = 32;
+  ts->u.irq = 33;
   ts->localStatus |= PORT_STATUS_SHIRQ;
   ts->boardId = BOARD_ID_7400;
 
@@ -64,19 +81,16 @@
 static int __init tsuart_init(void)
 {
   int ports=0;
-  int ret;
 	
   if (get_ts_model() != TS_MODEL_7400) {
     printk("TS-UART/7400 did not detect a TS-7400 board\n");
     return -1;
+  } 
+  if (ts7412_detect_test(0)) {
+    printk("TS-UART/7400 detected a TS-7400 with TS-7412 present\n");
   } else {
     printk("TS-UART/7400 detected a TS-7400 board\n");
   }
-  ret = procfile_init();
-  if (ret) {
-    return ret;
-  }
-
   if (tryInitPort(0x12400000)) {
     ports++;
   }
@@ -85,7 +99,6 @@
 
 static void __exit tsuart_exit(void)
 {
-  procfile_exit();  
 }
 
 module_init(tsuart_init);
Index: drivers/serial/tsuart940.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/serial/tsuart940.c,v
retrieving revision 1.1
retrieving revision 1.4
diff -u -r1.1 -r1.4
--- drivers/serial/tsuart940.c	16 May 2006 19:11:31 -0000	1.1
+++ drivers/serial/tsuart940.c	5 Sep 2006 22:44:31 -0000	1.4
@@ -33,6 +33,8 @@
 #include <asm/uaccess.h>
 #include "tsuart.h"
 
+#define BOARD_ID_940 0x940
+
 static int tryInitPort(int iobase) {
   struct tsuart_port *ts,*ts2;
   unsigned val;
@@ -57,6 +59,9 @@
   ts->debugFlags = portDebug;
   ts->u.iobase = TS7XXX_IO8_BASE + TS7XXX_ISAIO + iobase;
   ts->u.irq = 33;
+  ts->mdmctrl = 0;
+  ts->localStatus |= PORT_STATUS_SHIRQ;
+  ts->boardId = BOARD_ID_940;
 
   ts2->u.iotype = SERIAL_IO_PORT;
   ts2->get = tsuartGetIO8;
@@ -64,6 +69,9 @@
   ts2->debugFlags = portDebug;
   ts2->u.iobase = TS7XXX_IO8_BASE + TS7XXX_ISAIO + iobase;
   ts2->u.irq = 33;
+  ts2->mdmctrl = 0;
+  ts2->localStatus |= PORT_STATUS_SHIRQ;
+  ts2->boardId = BOARD_ID_940;
 
   val = tsuartGetIO8(ts,0);
   if (val == 0x3C) {
